Index: pbx/pbx_spool.c
===================================================================
--- pbx/pbx_spool.c	(revision 25289)
+++ pbx/pbx_spool.c	(working copy)
@@ -66,7 +66,7 @@
 	/* How long to wait for an answer */
 	int waittime;
 	/* PID which is currently calling */
-	int callingpid;
+	pid_t callingpid;
 	
 	/* What to connect to outgoing */
 	char tech[256];
@@ -193,7 +193,7 @@
 				} else if (!strcasecmp(buf, "retry")) {
 					o->retries++;
 				} else if (!strcasecmp(buf, "startretry")) {
-					if (sscanf(c, "%d", &o->callingpid) != 1) {
+					if (sscanf(c, "%ld", (long *)&o->callingpid) != 1) {
 						ast_log(LOG_WARNING, "Unable to retrieve calling PID!\n");
 						o->callingpid = 0;
 					}
Index: include/asterisk/options.h
===================================================================
--- include/asterisk/options.h	(revision 25289)
+++ include/asterisk/options.h	(working copy)
@@ -114,7 +114,7 @@
 
 extern time_t ast_startuptime;
 extern time_t ast_lastreloadtime;
-extern int ast_mainpid;
+extern pid_t ast_mainpid;
 
 extern char record_cache_dir[AST_CACHE_DIR_LEN];
 extern char debug_filename[AST_FILENAME_MAX];
Index: asterisk.c
===================================================================
--- asterisk.c	(revision 25289)
+++ asterisk.c	(working copy)
@@ -171,7 +171,7 @@
 
 static int ast_socket = -1;		/*!< UNIX Socket for allowing remote control */
 static int ast_consock = -1;		/*!< UNIX Socket for controlling another asterisk */
-int ast_mainpid;
+pid_t ast_mainpid;
 struct console {
 	int fd;				/*!< File descriptor */
 	int p[2];			/*!< Pipe */
@@ -722,7 +722,7 @@
 	
 	if (gethostname(hostname, sizeof(hostname)-1))
 		ast_copy_string(hostname, "<Unknown>", sizeof(hostname));
-	snprintf(tmp, sizeof(tmp), "%s/%d/%s\n", hostname, ast_mainpid, ASTERISK_VERSION);
+	snprintf(tmp, sizeof(tmp), "%s/%ld/%s\n", hostname, (long)ast_mainpid, ASTERISK_VERSION);
 	fdprint(con->fd, tmp);
 	for(;;) {
 		fds[0].fd = con->fd;
@@ -2514,22 +2514,22 @@
 	unlink(ast_config_AST_PID);
 	f = fopen(ast_config_AST_PID, "w");
 	if (f) {
-		fprintf(f, "%d\n", (int)getpid());
+		fprintf(f, "%ld\n", (long)getpid());
 		fclose(f);
 	} else
 		ast_log(LOG_WARNING, "Unable to open pid file '%s': %s\n", ast_config_AST_PID, strerror(errno));
 
 	if (ast_opt_always_fork || !ast_opt_no_fork) {
 		daemon(0, 0);
+		ast_mainpid = getpid();
 		/* Blindly re-write pid file since we are forking */
 		unlink(ast_config_AST_PID);
 		f = fopen(ast_config_AST_PID, "w");
 		if (f) {
-			fprintf(f, "%d\n", (int)getpid());
+			fprintf(f, "%ld\n", (long)ast_mainpid);
 			fclose(f);
 		} else
 			ast_log(LOG_WARNING, "Unable to open pid file '%s': %s\n", ast_config_AST_PID, strerror(errno));
-		ast_mainpid = getpid();
 	}
 
 	/* Test recursive mutex locking. */
@@ -2656,7 +2656,7 @@
 		/* Register our quit function */
 		char title[256];
 		set_icon("Asterisk");
-		snprintf(title, sizeof(title), "Asterisk Console on '%s' (pid %d)", hostname, ast_mainpid);
+		snprintf(title, sizeof(title), "Asterisk Console on '%s' (pid %ld)", hostname, (long)ast_mainpid);
 		set_title(title);
 
 		for (;;) {
Index: logger.c
===================================================================
--- logger.c	(revision 25289)
+++ logger.c	(working copy)
@@ -722,7 +722,7 @@
 	if (logfiles.event_log && level == __LOG_EVENT) {
 		va_start(ap, fmt);
 
-		fprintf(eventlog, "%s asterisk[%d]: ", date, getpid());
+		fprintf(eventlog, "%s asterisk[%ld]: ", date, (long)getpid());
 		vfprintf(eventlog, fmt, ap);
 		fflush(eventlog);
 
